> This page is for API, version 2026-01-01 (Stable) (default).
> For other versions, use one of these documentation indexes:
> - 2026-01-01 (Stable) (default): https://developer.deel.com/api/stable/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Create an immigration case

POST https://api.letsdeel.com/rest/immigration/client/cases
Content-Type: application/json

Creates a new immigration case for a worker. The appropriate visa type must be determined before calling this endpoint.

 **Token scopes**: `immigration:write`

Reference: https://developer.deel.com/api/endpoints/immigration/create-client-case

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Body (application/json)

This endpoint expects an object.

- `data` (ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaData, optional)

## Response

### 201

Successful operation.

- `data` (ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaData, required) — The immigration case data returned after successful creation

## Errors

### 400 Bad Request Error

Operation failed.

- `errors` (list of ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 401 Unauthorized Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 500 Internal Server Error

Operation failed.

- `errors` (list of ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaErrorsItems, optional)

## Types

### ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaData

### ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaData

The immigration case data returned after successful creation

- `id` (string, required) — Unique identifier for the case
- `status` (enum, required) — Current status of the case
  - Allowed values: `OPEN`, `CLOSED`, `ON_HOLD`
- `process` (ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaDataProcess, required) — Details about the current immigration process associated with the case
- `created_at` (string, required) — Timestamp when the case was created
- `updated_at` (string, required) — Timestamp when the case was last updated
- `closure_note` (string, optional, nullable) — Optional note explaining why the case was closed
- `closure_reason` (string, optional, nullable) — Standardized reason for case closure

### ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, optional) — Machine-readable error code
- `message` (string, optional) — Human-readable explanation of the error

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

### Right to Work Case

- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `RIGHT_TO_WORK`
- `contract_id` (string, required) — The contract object identifier. Required for document reviews and visa applications
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed

### EOR Visa Case

- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `EOR_VISA`
- `contract_id` (string, required) — The contract object identifier. Required for document reviews and visa applications
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed
- `visa_type_id` (string, optional) — The id of visa type that is being applied for. Identifies the type of the visa.

### Sponsored Visa Case

- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `SPONSORED_VISA`
- `entity_id` (string, required) — The unique identifier of the entity sponsoring the visa. Required for sponsored visa applications
- `contract_id` (string, required) — The contract object identifier. Required for document reviews and visa applications
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed
- `visa_type_id` (string, optional) — The id of visa type that is being applied for. Identifies the type of the visa.

### Pre-hire EOR Visa Case

- `team_id` (string, required) — The unique identifier of the team for which the pre-hire visa case is being created
- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `PRE_HIRE_EOR_VISA`
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed
- `visa_type_id` (string, optional) — The id of visa type that is being applied for. Identifies the type of the visa.

### Pre-hire Sponsorship Visa Case

- `team_id` (string, required) — The unique identifier of the team for which the pre-hire sponsorship visa case is being created
- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `PRE_HIRE_SPONSORSHIP_VISA`
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed
- `entity_id` (string, optional) — The unique identifier of the entity sponsoring the visa. Required for sponsored visa applications
- `visa_type_id` (string, optional) — The id of visa type that is being applied for. Identifies the type of the visa.

### Business Visa Case

- `case_type` (enum, required) — The type of immigration case to be created. Determines the workflow and requirements
  - Allowed values: `BUSINESS_VISA`
- `country_code` (string, required) — ISO 3166-1 alpha-2 country code where the immigration case needs to be processed
- `visa_type_id` (string, required) — The id of visa type that is being applied for. Identifies the type of the visa
- `employee_details` (ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaDataOneOf5EmployeeDetails, required) — Employee information. Citizenships and residence attributes are always required for business visa cases. The remaining fields are only required when no contract_id is present.
- `travel_information` (ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaDataOneOf5TravelInformation, required) — Travel details for the business visa
- `team_id` (string, optional) — The id of the team for which the employee will be added to. Required if contract_id is not provided
- `entity_id` (string, optional) — The unique identifier of the entity sponsoring the visa. Required for sponsored visa applications
- `contract_id` (string, optional) — The contract object identifier. If not provided, team_id is required and employee_details must include first_name, last_name, and email.

### ImmigrationClientCasesPostResponsesContentApplicationJsonSchemaDataProcess

Details about the current immigration process associated with the case

- `id` (string, required) — Unique identifier for the process
- `status_name` (string, required) — Human-readable status of the process
- `process_name` (string, required) — Name of the immigration process

### ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaDataOneOf5EmployeeDetails

Employee information. Citizenships and residence attributes are always required for business visa cases. The remaining fields are only required when no contract_id is present.

- `residence` (string, required) — ISO 3166-1 alpha-2 country code of employee's current residence
- `citizenships` (list of string, required) — List of ISO 3166-1 alpha-2 country codes representing employee's citizenships
- `email` (string, optional) — Employee's email address. Required if contract_id is not provided
- `last_name` (string, optional) — Employee's last name. Required if contract_id is not provided
- `first_name` (string, optional) — Employee's first name. Required if contract_id is not provided

### ImmigrationClientCasesPostRequestBodyContentApplicationJsonSchemaDataOneOf5TravelInformation

Travel details for the business visa

- `purpose` (enum, required) — The purpose of the business trip
  - Allowed values: `INTERNAL_BUSINESS_WITH_WORK_FOR_CLIENT`, `INTERNAL_BUSINESS_WITHOUT_WORK_FOR_CLIENT`, `MEETINGS_WITH_OR_FOR_A_CLIENT`, `MEETINGS_WITH_POTENTIAL_CLIENTS`, `NEGOTIATING_CONTRACTS_OR_SIGNING_AGREEMENTS`, `OTHER_EXTERNAL_BUSINESS`, `CONFERENCE`, `TEAM_OFFSITE`, `SPEAKING_AT_CONFERENCE_UNPAID`, `SPEAKING_AT_CONFERENCE_PAID`, `ATTENDING_INTERNAL_TRAINING`, `ATTENDING_EXTERNAL_TRAINING`, `DELIVERING_TRAINING_TO_INTERNAL_PARTICIPANTS`, `DELIVERING_TRAINING_TO_EXTERNAL_PARTICIPANTS_UNPAID`, `DELIVERING_TRAINING_TO_EXTERNAL_PARTICIPANTS_PAID`, `PARTICIPATION_IN_RESEARCH_PROJECTS_AND_STUDIES`, `ASSEMBLY_MAINTENANCE_REPAIR_INSTALLATION`, `TECHNICAL_SUPPORT_OR_SUPERVISION`, `OTHER_HANDS_ON_LABOUR`, `MARKET_RESEARCH_AND_EXPLORING_INVESTMENT_OPPORTUNITIES`, `OTHER`
- `end_date` (string, required) — Trip end date in YYYY-MM-DD format
- `start_date` (string, required) — Trip start date in YYYY-MM-DD format

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "data": {
    "id": "223e4567-e89b-12d3-a456-426614174111",
    "status": "OPEN",
    "process": {
      "id": "223e45611-e19b-12d3-a456-426614174000",
      "status_name": "Document Review",
      "process_name": "Right to Work Verification"
    },
    "created_at": "2024-12-10T15:45:00Z",
    "updated_at": "2024-12-10T15:45:00Z",
    "closure_note": "All requirements met and visa approved",
    "closure_reason": "COMPLETED_SUCCESSFULLY"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.letsdeel.com/rest/immigration/client/cases"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/immigration/client/cases';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/immigration/client/cases"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/immigration/client/cases")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/immigration/client/cases")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/immigration/client/cases', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/immigration/client/cases");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/immigration/client/cases")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```